package com.emsi.tp1biir72.view;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;

import com.emsi.tp1biir72.controller.MyAPI;
import com.emsi.tp1biir72.R;
import com.emsi.tp1biir72.controller.RetrofitSingleton;
import com.emsi.tp1biir72.model.User;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

public class LoginActivity extends AppCompatActivity implements View.OnClickListener {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_login);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });
        Button btnConnect = findViewById(R.id.btnConnect);
        btnConnect.setOnClickListener(this);
    }

    @Override
    public void onClick(View view) {
        EditText txtLogin = findViewById(R.id.txtLogin);
        EditText txtPass = findViewById(R.id.txtPass);
        String login=txtLogin.getText().toString();
        String pass=txtPass.getText().toString();

        MyAPI api= RetrofitSingleton.getInstance().create(MyAPI.class); //on crée une instance de l'interface
        Call<User> call=api.login(login, pass);
        call.enqueue(new Callback<User>() {
            @Override
            public void onResponse(Call<User> call, Response<User> res) {
                if(res.isSuccessful()){
                    User user = res.body();
                    if(user == null || user.getSessionToken() == null){
                        Toast.makeText(LoginActivity.this, "Login/pass incorrects!", Toast.LENGTH_LONG).show();
                    }else {
                        Intent intent = new Intent(getApplicationContext(), MainActivity.class);
                        intent.putExtra("user", user);
                        startActivity(intent);
                        LoginActivity.this.finish();
                    }
                }else{
                    Toast.makeText(LoginActivity.this, "Réponse serveur incorrecte!", Toast.LENGTH_LONG).show();
                }
            }

            @Override
            public void onFailure(Call<User> call, Throwable t) {
                Toast.makeText(LoginActivity.this, "Erreur de connexion", Toast.LENGTH_LONG).show();
            }
        });

    }
}